//=============================================================================
// BotzPathObject.
// Que mejor forma de manejar el complicado sistema en la averiguacin de
// caminos de mis botz que haciendo un Class de puro script y que consume mucho
// menos memoria que un Actor o que complica menos que un Struct y funciones
// raras, basado en el tpico modelo de una clase C++ que es facilmente creada
// y (destruida, noooo, no se destruye), prctica y simple, con todas las funciones necesarias.
// PD. Complicado no, asquerosamente inmundo
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class BotzPathObject expands Object;

var float Distance;
var BotzJunction Start, Target, Trail[60];
var bool bIsInit;	// Algo simple, evitar amenazas externas en la versin final (sin scripts, eliminados manualmente por seguridad)
var bool TranslocType;
var bool JumpType;
var string Descripcion;

static final function BotzPathObject Init( BotzJunction NewTrail[60], bool NewT, bool NewJ)
{
	local BotzPathObject NewBPO;
	local int i;

	NewBPO = New class'BotzPathObject';
	NewBPO.TranslocType = NewT;
	NewBPO.JumpType = NewJ;
	NewBPO.bIsInit = True;
	For (i=0 ; i<60 ; i++)
	{	if ( NewTrail[i] == none )
			break;
		NewBPO.Trail[i] = NewTrail[i];
	}
	NewBPO.Start = NewTrail[0];
//	NewBPO.Target = NewTrail[ CountI(NewTrail) - 1];
	NewBPO.Target = NewTrail[ i - 1];
	NewBPO.Distance = CalculateDist( NewTrail );
//	NewBPO.Log("Reportando: Creacin de BPO, distancia es"@string(int(NewBPO.Distance)));
	return NewBPO;
}

static final function bool SamePath( BotzPathObject A, BotzPathObject B)
{
	local int i;

	For ( i=0 ; i<60 ; i++ )
	{
		if ( A.Trail[i] != B.Trail[i] )
			return false;
	}
	return True;
}

static final function BotzPathObject GetBestTranslocPath( BotzPathObject A,BotzPathObject B)
{
	local BotzPathObject Best;

	if (A == none)
		return B;
	if (B == none)
		return A;

	Assert ( A.Start == B.Start );
	Assert ( B.Target == A.Target );
	Assert ( A.bIsInit && B.bIsInit );

	if ( !A.TranslocType && A.JumpType && !B.TranslocType && B.JumpType)
	{
		Log("Error: Se llam GetBestTransloc usando dos JumpType paths!");
		return none;
	}

	if ( A.Distance <= B.Distance )
	{
		if ( !A.TranslocType && A.JumpType)
			Best = B;
		else
			Best = A;
	}
	else
	{
		if ( !B.TranslocType && B.JumpType)
			Best = A;
		else
			Best = B;
	}
	return Best;
}

static final function BotzPathObject GetBestJumpPath( BotzPathObject A, BotzPathObject B)
{
	local BotzPathObject Best;

	if (A == none)
		return B;
	if (B == none)
		return A;

	Assert ( A.Start == B.Start );
	Assert ( B.Target == A.Target );
	Assert ( A.bIsInit && B.bIsInit );

	if ( A.TranslocType && !A.JumpType && B.TranslocType && !B.JumpType)
	{
		Log("Error: Se llam GetBestJump usando dos TranslocType paths!");
		return none;
	}

	if ( A.Distance <= B.Distance )
	{
		if ( A.TranslocType && !A.JumpType)
			Best = B;
		else
			Best = A;
	}
	else
	{
		if ( B.TranslocType && !B.JumpType)
			Best = A;
		else
			Best = B;
	}
	return Best;
}

static final function BotzPathObject GetBestNormalPath( BotzPathObject A, BotzPathObject B)
{
	local BotzPathObject Best;

	if (A == none)
		return B;
	if (B == none)
		return A;

//	Assert ( A.Start == B.Start );
//	Assert ( B.Target == A.Target );
//	Assert ( A.bIsInit && B.bIsInit );

	if ( (A.TranslocType || A.JumpType) && (B.TranslocType || B.JumpType) )
	{
		Log("Error: Se llam GetBestNormal usando dos caminos especiales!");
		return none;
	}

	if ( A.Distance <= B.Distance )
	{
		if ( A.TranslocType || A.JumpType)
			Best = B;
		else
			Best = A;
	}
	else
	{
		if ( B.TranslocType || B.JumpType)
			Best = A;
		else
			Best = B;
	}
	return Best;
}

static final function int CountI( Object L[60])
{
	local int i;

	if ( L[32] != none ) //Anti iteration tweak
		For ( i=60 ; i>0 ; i-- )
			if ( L[i-1] != none )
				return i;

	For ( i=0 ; i<60 ; i++ )
		if ( L[i] == none )
			return i;
}

static final function int FindI( Object L[60], Object Sample)
{
	local int i;

	For ( i=0 ; i<60 ; i++ )
		if ( L[i] == Sample )
			return i;
	return -1;
}

static final function float CalculateDist( BotzJunction JuncList[60] )
{
	local int i, j, lul;
	local float Result;

	lul = CountI( JuncList) - 2;
	For ( i=0 ; i< (lul) ; i++ )
	{
		For (j=0 ; j<8 ; j++)
			if ( JuncList[i].LinkedJunctions[j] == JuncList[i + 1] )
			{
				if ( JuncList[i].LinkedDistances[j] == 0 )
					JuncList[i].LinkedDistances[j] = BotzWp(JuncList[i].LinkedPaths[j]).PathInfo.GetDist( JuncList[i], JuncList[i+1] ) ;
				Result += JuncList[i].LinkedDistances[j];
				j = 8;
			}
	}
	return result;
}

final function ReportIn()
{
	local string AttT;

	if ( TranslocType )
		AttT = "Transloc,";
	if ( jumpType )
		AttT = AttT@"JumpType";
	log("BPO: Comienzo es"@Start$", Final es"@Target$"."@AttT);
}

defaultproperties
{
}
